单调栈
- 什么时候用单调栈
通常是一维数组,要寻找任一个元素的右边或者左边第一个比自己大或者小的元素的位置,此时我们就要想到可以用单调栈了。时间复杂度为O(n)。 - 单调栈的原理
单调栈的本质是空间换时间,因为在遍历的过程中需要用一个栈来记录右边第一个比当前元素高的元素,优点是整个数组只需要遍历一次。
就是用一个栈来记录我们遍历过的元素,因为我们遍历数组的时候,我们不知道之前都遍历了哪些元素,以至于遍历一个元素找不到是不是之前遍历过一个更小的,所以我们需要用一个容器(这里用单调栈)来记录我们遍历过的元素。 - 在使用单调栈的时候首先要明确如下几点:
单调栈里存放的元素是什么?
单调栈里只需要存放元素的下标i就可以了,如果需要使用对应的元素,直接T[i]就可以获取。
单调栈里元素是递增呢? 还是递减呢?
739. 每日温度
https://leetcode.cn/problems/daily-temperatures/
本题要找右边第一个比自己大的元素,符合单调栈解题思路。
class Solution {
public int[] dailyTemperatures(int[] temperatures) {
int[] answer=new int[temperatures.length];
Deque<Integer> stack=new LinkedList<>();
stack.push(0);
for(int i=1;i<temperatures.length;i++){
while(!stack.isEmpty()&&temperatures[i]>temperatures[stack.peek()]){
answer[stack.peek()]=i-stack.peek();
stack.pop();
}
stack.push(i);
}
return answer;
}
}
496. 下一个更大元素 I
https://leetcode.cn/problems/next-greater-element-i/
比上一题复杂一些,但还是可以在它的基础上更改。
class Solution {
public int[] nextGreaterElement(int[] nums1, int[] nums2) {
int[] answer=new int[nums1.length];
//Arrays.fill(res,-1);
for(int i=0;i<nums1.length;i++){
answer[i]=-1;
}
HashMap<Integer, Integer> hashMap = new HashMap<>();
for (int i = 0 ; i< nums1.length ; i++){
hashMap.put(nums1[i],i);
}
Deque<Integer> stack=new LinkedList<>();
stack.push(0);
for(int i=1;i<nums2.length;i++){
while(!stack.isEmpty()&&nums2[i]>nums2[stack.peek()]){
if(hashMap.containsKey(nums2[stack.peek()])){
answer[hashMap.get(nums2[stack.peek()])]=nums2[i];
}
stack.pop();
}
stack.push(i);
}
return answer;
}
}